#include <SPI.h> 
#include "mcp_can.h"
#include <mcp_can_dfs.h>
//this is for logging into your flatpack. Must use your serial number.
// first unit
unsigned char login[8] = {0x16, 0x36, 0x71, 0x07, 0x03, 0x76, 0x00, 0x00}; 
// 2nd unit
//unsigned char login[8] = {0x18, 0x10, 0x50, 0x01, 0x76, 0x09, 0x00, 0x00}; 
// test units
//unsigned char login[8] = {0x20, 0x15, 0x50, 0x01, 0x82, 0x94, 0x00, 0x00}; 
//unsigned char login[8] = {0x19, 0x40, 0x50, 0x00, 0x45, 0x95, 0x00, 0x00}; 

// D13 is SPI clock, SCK
// D12 MISO, master in, slave out, SO
// D11 MOSI, master out, slave in, SI


const int SPI_CS_PIN = 10;
MCP_CAN CAN(SPI_CS_PIN); // Set CS pin

#define VOLTAGE 4800
#define CURRENT 450

//uint8_t outset[8] = {CURRENT & 0xff, (CURRENT >> 8) & 0xff, VOLTAGE & 0xFF, (VOLTAGE >> 8) & 0xFF ,VOLTAGE & 0xFF, (VOLTAGE >> 8) & 0xFF ,0x3E, 0x17};
//volatile int got_cb_data = 0;
// 0x1130 = 44.00V
// 0x12C0 = 48.00V
// 0x1680 = 57.60V
// low byte first  {0x29, 0x15, 0x00, 0x30, 0x11}; 
unsigned char setdefaultvolt[5] = {0x29, 0x15, 0x00, 0xc0, 0x12}; 

void setup()
{
    Serial.begin(115200);
    pinMode(3,INPUT);
    pinMode(12,INPUT);
START_INIT:
    if(CAN_OK == CAN.begin(MCP_ANY, CAN_125KBPS, MCP_8MHZ))
    {
        Serial.println("CAN BUS Shield init ok!");
    }
else
    {
    Serial.println("CAN BUS Shield init fail");
    Serial.println("Init CAN BUS Shield again");
    delay(1000);
    goto START_INIT;
    }

CAN.setMode(0);    
delay(200);
CAN.sendMsgBuf(0x05004804, 1, 8, login);    // id = 1 so XX = 04     
delay(200);
CAN.sendMsgBuf(0x05019C04, 1, 5, setdefaultvolt);  
}


void loop() 
{
 
}   
